Component({
  mixins: [],
  data: {
    // hDir: "",//横向 left right
    // vDir: "",//纵向 Top Bottom
    pre2: {
      //上两个id
      idx: -1,
      posDir: "",
    },
    pre1: {
      //上一个id
      idx: -1,
      posDir: "",
    },
    cur: {
      //当前id
      idx: -1,
      posDir: -1,
    },
    next1: {
      //下一个id
      idx: -1,
      posDir: "",
    },
    next2: {
      //下两个id
      idx: -1,
      posDir: "",
    },
    items: [
      // { classIdx: "0" }, { classIdx: "1" }, { classIdx: "2" }, { classIdx: "3" }, { classIdx: "4" }, { classIdx: "5" }
    ]
  },
  props: {},
  async didMount() {
    my.tt = this;
    // 1.先查询容器尺寸
    let res = await this.dom("#ftempBox");
    let dom = res.data;
    this.setData({
      dom
    }, () => {
      this.initItems(this.props.gameSource.items, (items) => {
        let curIdx = this.props.curIdx || 0;
        this.setCurIdx(curIdx, () => {
          console.error(items);
          this.setData({
            items
          }, () => {
            this.props.onInitDone && this.props.onInitDone(this);
          })
        }, items)
      });
    })
  },
  didUpdate() { },
  didUnmount() { },
  methods: {
    dom(className) {
      return new Promise(function (resolve, reject) {
        let result = {};
        my.createSelectorQuery()
          .select(className)
          .boundingClientRect()
          .exec(([ret]) => {
            if (ret) {
              result.success = true;
              result.data = ret;
            } else {
              result.success = false;
            }
            resolve(result);
          });
      });
    },
    initItems(items, callback) {
      let tempItems = JSON.parse(JSON.stringify(items));
      if (tempItems.length <= 5) {
        tempItems = tempItems.concat(tempItems);
        this.initItems(tempItems, callback)
      } else {
        tempItems.forEach((item, idx) => {
          item.classIdx = idx;
        })
        callback && callback(tempItems);
      }
    },
    onClickFun(e) {
      let { currentTarget: { dataset: { item } } } = e;
      console.error(item)
    },
    getIdx(items, idx) {
      let minIdx = 0, maxIdx = items.length - 1;
      if (idx < 0) {
        return maxIdx;
      } else if (idx > maxIdx) {
        return minIdx;
      } else {
        return idx;
      }
    },
    getPreDir(dir) {
      if (dir == "leftBottom") {
        return "leftTop";
      } else if (dir == "leftTop") {
        return "leftBottom";
      }
    },
    getNextDir(dir) {
      if (dir == "rightTop") {
        return "rightBottom";
      } else if (dir == "rightBottom") {
        return "rightTop";
      }
    },
    setCurIdx(idx1, callback, tempItems) {
      let items = tempItems || this.data.items;
      let idx;
      if (typeof idx1 == "undefined") {
        idx = (this.data.curIdx || 0) + 1;
      } else {
        idx = idx1;
      }
      idx = idx % items.length;

      let curIdx = this.getIdx(items, idx);
      let preIdx1 = this.getIdx(items, curIdx - 1);
      let preIdx2 = this.getIdx(items, preIdx1 - 1);
      let nextIdx1 = this.getIdx(items, curIdx + 1);
      let nextIdx2 = this.getIdx(items, nextIdx1 + 1);

      let pre2Dir = "", pre1Dir = "", curDir = "def", next1Dir = "", next2Dir = "";
      let defDir = this.props.gameSource.defLeftPos || "leftBottom";
      if (defDir != "leftBottom" && defDir != "leftTop") {
        defDir = "leftBottom";
      }
      let defNextDir = "rightTop";
      if (defDir == "leftBottom") {
        defNextDir = "rightTop";
      } else if (defDir == "leftTop") {
        defNextDir = "rightBottom";
      }
      // hDir: "",//横向 left right
      // vDir: "",//纵向 Top Bottom
      let oldIdx = this.data.cur.idx;
      let oldDir = this.data.cur.posDir;
      if (oldDir == -1) {
        // 第一次渲染
        pre1Dir = defDir;
        pre2Dir = this.getPreDir(pre1Dir);
        next1Dir = this.getNextDir(defNextDir);
        next2Dir = defNextDir;
      } else {
        pre1Dir = this.data.pre2.posDir;
        pre2Dir = this.data.pre1.posDir;
        next1Dir = this.data.next2.posDir;
        next2Dir = this.data.next1.posDir;
      }

      this.setData({
        pre2: {
          idx: preIdx2,
          posDir: pre2Dir,
        },
        pre1: {
          idx: preIdx1,
          posDir: pre1Dir,
        },
        cur: {
          idx: curIdx,
          posDir: curDir,
        },
        next1: {
          idx: nextIdx1,
          posDir: next1Dir,
        },
        next2: {
          idx: nextIdx2,
          posDir: next2Dir,
        },
      }, () => {
        callback && callback();
      })
    },
    prev() {
      if (this.aniStatus) { return false; }
      this.aniStatus = true;
      this.setCurIdx(this.data.cur.idx - 1);
    },
    next() {
      if (this.aniStatus) { return false; }
      this.aniStatus = true;
      this.setCurIdx(this.data.cur.idx + 1);
    },
    aniEndFun() {
      if (this.aniStatus) {
        // 回调
        this.aniStatus = false;
        this.props.onChangeFun && this.props.onChangeFun(this.data.cur.idx);
      }
    }
  },
});